View Issue Details

IDProjectCategoryView StatusLast Update
0001290OpenFOAM[All Projects] Bugpublic2017-06-30 10:24
Reporteruser676Assigned Touser2 
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
PlatformLinuxOSUbuntuOS Version10.04
Product Version 
Fixed in Version 
Summary0001290: RotorDiskSource. Forces coordinate transformation
DescriptionIn relation to the bug: 0000708

The similar procedure must be done to convert from local cylindrical system to global cartesian system like it was done previously for U vector when changing from global cartesian to local cylindrical:

            // convert force from local coning system into rotor cylindrical
            localForce = invR_[i] & localForce;

            // convert force to global cartesian co-ordinate system
            force[cellI] = coordSys_.globalVector(localForce);

coorSys_ can not be used for vectors and the new "localAxesRotation" code must be used:
            // convert force from local coning system into rotor cylindrical
            localForce = invR_[i] & localForce;
            // convert force to global cartesian co-ordinate system
            localForce(localAxesRotation_->invTransform(localForce));

Other option that I am not sure, if it is possible to access the tensor directly without using the new "localAxesRotation" code:
//velocity in local cylindrical reference frame
vector Uc = coordSys_R().R().T() & U[cellI]; //to orientate according to disk axis system
Uc = Rcyl_[i] & Uc; //Rcyl tensor define local cartesian to local cylindrical coords.
//transform from rotor cylindrical to coning system
Uc = R_[i] & Uc;
..
..
..
//convert force from local coning to local cylindrical
localForce = invR_[i] & localForce;
//convert from
localForce = invRcyl_[i] & localForce;
force[cellI] = coordSys_R().R() & localForce;

TagsNo tags attached.

Activities

user2

2014-05-13 16:19

  ~0003058

Thanks for the report - fixed by commit f81efcd

user676

2014-06-09 09:53

  ~0003115

The bug has not been resolved correctly neither for forces neither for U vector.
You could find a test case in this other bug report
http://www.openfoam.org/mantisbt/view.php?id=1313

The option that I gave works correctly. The proposed fixed solution does not.

user951

2014-06-13 15:00

  ~0003134

Is this bug already solved or not? It seems there are a lot of discrepancies, and e.g. be_inspired is using lots of ad-hoc local implementation. Is there some type of official bug resolved feedback for this? Thanks.

henry

2014-12-21 18:08

manager   ~0003350

I agree that this bug has not been fixed; currently it appears that it is only possible to solve cases for which the rotor axis is aligned with the z-axis. In the simple test-case in #1313 the rotor is aligned with the y-axis and absolute nonsense is generated.

Do you have an updated fix for the coordinate transformation problem? I would be happy to apply a patch. If not I will look into it further.

henry

2014-12-22 10:19

manager   ~0003353

Resolved by commit 3d782bec68602ee3f0f8120e88931e9a35f90ca0

It appears that in your proposal the localForce is transformed from global->local rather than local->global. I have corrected this and the oposite error in the transformation of Uc. Now the small test case supplied in #1313 runs with the rotor-axis alligned with the y or z axis but I have not tested the x-axis or an arbitrary axis.

Could you please test this commit on your cases and report back before I close this bug-report?

Thanks.

chris

2017-06-30 10:24

manager   ~0008288

Fixed. No feedback from reporter.

Issue History

Date Modified Username Field Change
2014-05-12 16:48 user676 New Issue
2014-05-13 16:19 user2 Note Added: 0003058
2014-05-13 16:19 user2 Status new => resolved
2014-05-13 16:19 user2 Fixed in Version => 2.3.x
2014-05-13 16:19 user2 Resolution open => fixed
2014-05-13 16:19 user2 Assigned To => user2
2014-06-09 09:53 user676 Note Added: 0003115
2014-06-09 09:53 user676 Status resolved => feedback
2014-06-09 09:53 user676 Resolution fixed => reopened
2014-06-13 15:00 user951 Note Added: 0003134
2014-12-21 18:08 henry Note Added: 0003350
2014-12-22 10:19 henry Note Added: 0003353
2017-06-30 10:24 chris Status feedback => closed
2017-06-30 10:24 chris Resolution reopened => fixed
2017-06-30 10:24 chris Note Added: 0008288